import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.*;

public class Paint implements MouseMotionListener, MouseListener{
	
	private JFrame mainFrame;
	
	private JPanel mainPanel;
	private JPanel drawingPanel;
	private JPanel buttonsPanel;
	
	private JButton clearButton;
	
	public Paint(){
		mainFrame = new JFrame("Dessin");							// Sets the name of the frame
		mainFrame.setSize(400, 300);								// Sets the size of the frame
		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	// Sets the default closing operation
	
		initPanels();
		initButtons();
		initListeners();
		
		mainFrame.setVisible(true);									// Specifies the MAIN frame must be visible
	}
	
	private void initPanels(){
		mainPanel = new JPanel(new BorderLayout());					// Creates a MAIN panel with a BorderLayout
		drawingPanel = new JPanel();								// Creates another panel for DRAWING
		drawingPanel.setBackground(Color.WHITE);					// Sets the background color of the DRAWING panel to white
		buttonsPanel = new JPanel();								// Creates another panel for the BUTTONS
		mainFrame.getContentPane().add(mainPanel);					// Adds the MAIN panel to the frame previously defined
		mainPanel.add(drawingPanel, BorderLayout.CENTER);			// Adds the DRAWING panel to the center of the MAIN panel
		mainPanel.add(buttonsPanel, BorderLayout.PAGE_END);			// Adds the BUTTON panel to the END (botton) of the MAIN panel
	}
	
	private void initButtons(){
		clearButton = new JButton();								// Creates a button
		clearButton.setText("Effacer");								// Sets the text present on the button
		buttonsPanel.add(clearButton);								// Adds the button to the appropriate panel
		
		clearButton.addActionListener(new ActionListener(){ 		// Defines the action to take when the button is pressed
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO
			}		
		});
	}
	
	private void initListeners(){		
		drawingPanel.addMouseMotionListener(this);					// Specifies the DRAWING panel must listen to the MOUSE actions
		drawingPanel.addMouseListener(this);
	}

	@Override
	public void mouseDragged(MouseEvent e) {						// Defines what to do when the Mouse is DRAGGED
		System.out.println("Mouse Dragged");	
	}

	@Override
	public void mouseMoved(MouseEvent e) {							// Defines what to do when the Mouse is MOVED
		System.out.print("Position of the mouse : (X,Y) = (");
		System.out.print(e.getX());
		System.out.print(" , ");
		System.out.print(e.getY());
		System.out.println(")");
	}

	@Override
	public void mouseClicked(MouseEvent e) {						// Defines what to do when the Mouse is CLICKED
		System.out.println("Here");
		Graphics g = drawingPanel.getGraphics();
		g.drawOval(e.getX(), e.getY(), 10, 10);
		g.dispose();		
	}

	@Override
	public void mousePressed(MouseEvent e) {						// Defines what to do when the Mouse is PRESSED
		System.out.println("Mouse Pressed");	
	}

	@Override
	public void mouseReleased(MouseEvent e) {						// Defines what to do when the Mouse is RELEASED
		System.out.println("Mouse Released");
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {						// Defines what to do when the Mouse ENTERED
		System.out.println("Mouse Entered");		
	}

	@Override
	public void mouseExited(MouseEvent e) {							// Defines what to do when the Mouse is EXITED
		System.out.println("Mouse Exited");		
	}

}
