import java.awt.Color;
import java.awt.Point;
import java.util.Random;

public class CircleButtonListener extends ShapeButtonListener {
	
	public CircleButtonListener(Drawing drawing){
		super(drawing);
	}
	
	
	protected Shape createShape() {
		double width = Math.abs(destination.getX()-origin.getX());
		double height = Math.abs(destination.getY()-origin.getY());
		double radius = Math.max(width, height)/2;
		double centerX = (destination.getX()+origin.getX())/2;
		double centerY = (destination.getY()+origin.getY())/2;
		Point center = new Point((int)centerX, (int)centerY);

		Random r = new Random();
		Color color = new Color(r.nextInt(256), r.nextInt(256), r.nextInt(256));
		Circle c = new Circle(center, radius, color);
		CircleThread t = new CircleThread(drawing, c, r.nextInt(50)+2);
		
		t.init();

		return c;
	}
}
